__doc__ = """EmployXManager product module.

See README.txt for more details."""


__version__ = '0.0.1'


from Globals import HTMLFile
#from Globals import MessageDialog
#from Globals import Persistent


from Products.ZPatterns.Specialists import Specialist, manage_addSpecialistForm
from Products.ZPatterns.SkinScript.Methods import SSMethod

#manage_addEmployXManagerForm = HTMLFile('EmployXManagerAdd', globals()) 

def manage_addSpecialist(self, id, title='', rack='', REQUEST=None):
    """Add a EmployXManager to a folder."""
    ob = EmployXManager(id, title)
    self._setObject(id,ob)
    ob = ob.__of__(self)

    if rack:
        ob.RacksGroup._constructPlugIn(rack, id='defaultRack')
        ob.defaultRack.manage_setStorage(
                zclass="Products.EmployX.EmployX/EmployX"
                )
        ob.defaultRack._installPlugIn(
            SSMethod('skinscript', title='Computed Attributes')
        )
                
        ob.defaultRack.skinscript.manage_edit('', DEFAULT_SKINSCRIPT)
        ob.defaultRack.DataPlugins.manage_first(ids=['skinscript'])
        
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


DEFAULT_SKINSCRIPT =  """WITH SELF COMPUTE total_cost = 999
WITH SELF COMPUTE fullname = first + " " + last
"""
                      
                      
class EmployXManager(Specialist):
    """Thing that manages EmployX"""
    
    meta_type = "EmployXManager" 

    newItemForm = HTMLFile('newItemForm', globals()) 
    index_html  = HTMLFile('index_html_manager', globals()) 

    def __init__(self, id, title = ''):
        Specialist.__init__(self, id, title)

    def addNewItem(self,emp_id ,REQUEST=None):
        """ttw"""
        ob = self.newItem(emp_id)
        ob.manage_changeProperties(REQUEST=REQUEST)
        
        if REQUEST is not None:
            return self.index_html(self, REQUEST,management_view='View')

    def deleteInstances(self,ids,REQUEST=None):
        """ttw"""
        for id in ids:
            ni = self.getItem(id)
            ni.manage_delete()
            
        if REQUEST is not None:
            return self.index_html(self, REQUEST,management_view='View')
    
           
            
def initialize(context): 
    """Initialize the EmployXManager product.
    """

    context.registerClass(
            EmployXManager,         
            constructors = (                 
                manage_addSpecialistForm, 
                manage_addSpecialist),                                                 
            icon = 'www/item.gif'                
        )


